<?php

class DefaultController extends Controller
{

    /**
     * @var string the default layout for the views. Defaults to '//layouts/column2', meaning
     * using two-column layout. See 'protected/views/layouts/column2.php'.
     */
    public $layout = '//layouts/column2';

    /**
     * @return array action filters
     */
    public function filters()
    {
        return array(
            'accessControl', // perform access control for CRUD operations
        );
    }

    /**
     * Specifies the access control rules.
     * This method is used by the 'accessControl' filter.
     * @return array access control rules
     */
    public function accessRules()
    {
        return array(
            array('allow', // allow all users to perform 'index' and 'view' actions
                'actions' => array('index', 'view'),
                //'users'=>array('@'),
                'expression' => AccessManager::checkSessionPermission($this->module->name),
            ),
            array('allow', // allow authenticated user to perform 'create' and 'update' actions
                'actions' => array('create', 'update', 'ajaxBeforeRecord'),
                //'users'=>array('@'),
                'expression' => AccessManager::checkSessionPermission($this->module->name),
            ),
            array('allow', // allow admin user to perform 'admin' and 'delete' actions
                'actions' => array('admin', 'delete'),
                //'users'=>array('@'),
                'expression' => AccessManager::checkSessionPermission($this->module->name),
            ),
            array('deny', // deny all users
                'users' => array('*'),
            ),
        );
    }

    public function actionAjaxBeforeRecord()
    {
        $jsonModel = $_REQUEST['model'];
        $model = null;
        if ($jsonModel['id'] != 'null') {
            $model = AudioFile::model()->findByPk($jsonModel['id']);
            $model->fileName = 'record';
        } else {
            if (isset($_POST['recordId']) && $_POST['recordId'] != "") {
                $model = AudioFile::model()->findByPk($_POST['recordId']);
            }
        }

        if (!$model) {
            $model = new AudioFile();
            $model->type = AudioFileType::systemType;
        }

        $model->scenario = 'record';
        if ($model->save()) {
            echo json_encode($model);
        } else {
            echo "no Data";
        }
    }

    /**
     * Displays a particular model.
     * @param integer $id the ID of the model to be displayed
     */
    public function actionView($id)
    {
        $this->render('view', array(
            'model' => $this->loadModel($id),
        ));
    }

    /**
     * Creates a new model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     */
    public function actionCreate()
    {
        $model = new AudioFile('create');
        $isRecorded = $this->mergeModelAndTempData($model);

        $this->performAjaxValidation($model);

        if (isset($_POST['AudioFile'])) {
            $model->attributes = $_POST['AudioFile'];

            $model->type = AudioFileType::systemType;
            if (!$isRecorded) {
                $model->validateUploadedData();
            }
            $usecase = 0;
            if (isset($_POST['usecases'])) {
                foreach ($_POST['usecases'] as $key => $flag) {
                    $usecase = $usecase + $flag;
                }
            }
            $model->usecase = $usecase;
            if ($model->save()) {
                Yii::app()->end();
            }
        }
        $this->renderPartial('_form', array('model' => $model), false, true);
    }

    public function mergeModelAndTempData(&$model)
    {
        $isRecorded = false;
        if (!isset($_POST['ajax'])) {
            if (isset($_POST['recordId']) && $_POST['recordId'] != '') {
                $modelTemp = AudioFile::model()->findByPk($_POST['recordId']);
                if ($modelTemp != null && $modelTemp->data != null) {
                    $model = $modelTemp;
                    $model->scenario = "update";
                    $isRecorded = true;
                    Log::d('setting scenario to update');
                } else {
                    if ($modelTemp) {
                        $modelTemp->delete();
                    }
                    unset($_POST['recordId']);
                    unset($_POST['AudioFile']['data']);
                }
            }
        }
        return $isRecorded;
    }

    /**
     * Updates a particular model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id the ID of the model to be updated
     */
    public function actionUpdate($id)
    {
        $model = $this->loadModel($id);
        $this->performAjaxValidation($model);

        if (isset($_POST['AudioFile'])) {
            $model->attributes = $_POST['AudioFile'];
            $usecase = 0;
            if (isset($_POST['usecases'])) {
                foreach ($_POST['usecases'] as $key => $flag) {
                    $usecase = $usecase + $flag;
                }
            }
            $model->usecase = $usecase;

            if (isset($_FILES['AudioFile']["data"]['size']) && $_FILES['AudioFile']["data"]['size'] > 0) {
                $model->validateUploadedData();
            }

            if ($model->save()) {
                $this->redirect(array('admin', 'id' => $model->id));
            }
        }
        $this->renderPartial('_form', array('model' => $model), false, true);
    }

    /**
     * Deletes a particular model.
     * If deletion is successful, the browser will be redirected to the 'admin' page.
     * @param integer $id the ID of the model to be deleted
     */
    public function actionDelete($id)
    {
        if (Yii::app()->request->isPostRequest) {
//             we only allow deletion via POST request
            $this->loadModel($id)->delete();

//             if AJAX request (triggered by deletion via admin grid view), we should not redirect the browser
            if (!isset($_GET['ajax'])) {
                $this->redirect(isset($_POST['returnUrl']) ? $_POST['returnUrl'] : array('admin'));
            }
        } else {
            throw new CHttpException(400, 'Invalid request. Please do not repeat this request again.');
        }
    }

    /**
     * Lists all models.
     */
    public function actionIndex()
    {
        $this->actionAdmin();
    }

    /**
     * Manages all models.
     */
    public function actionAdmin()
    {
        $model = new AudioFile('search');
        $model->unsetAttributes();  // clear any default values
        if (isset($_GET['AudioFile'])) {
            $model->attributes = $_GET['AudioFile'];
        }
        $this->render('admin', array(
            'model' => $model,
        ));
    }

    /**
     * Returns the data model based on the primary key given in the GET variable.
     * If the data model is not found, an HTTP exception will be raised.
     * @param integer the ID of the model to be loaded
     */
    public function loadModel($id)
    {
        $model = AudioFile::model()->findByPk($id);
        if ($model === null) {
            throw new CHttpException(404, 'The requested page does not exist.');
        }
        return $model;
    }

    /**
     * Performs the AJAX validation.
     * @param CModel the model to be validated
     */
    protected function performAjaxValidation($model)
    {
        if (isset($_POST['ajax']) && $_POST['ajax'] === 'audio-files-form') {
            echo CActiveForm::validate($model);
            Yii::app()->end();
        }
    }

    public function getTabularFormTabs($form, $model)
    {
        $tabs = array();
        $count = 0;
        $translateKeys = array(
            'generalData' => __('PHONESETTINGS_AUDIOFILES_CONTROLLER_TAB_MENU_GENERAL_DATA'),
            'usecases' => __('PHONESETTINGS_AUDIOFILES_CONTROLLER_TAB_MENU_USECASE'),
        );
        foreach ($translateKeys as $view => $tabLabel) {
            $tabs[] = array(
                'active' => $count++ === 0,
                'label' => $tabLabel,
                'content' => $this->renderPartialWithContextHelp($view, array('form' => $form, 'model' => $model), true),
            );
        }
        return $tabs;
    }

    public function getUseCaseColumns($model)
    {
        $columns = array(
            array(
                'header' => __('AUDIOFILE_CONTROLLER_USECASE_GRID_SECTION_HEADER'),
                'headerHtmlOptions' => array(
                    'data-translation-id' => 'AUDIOFILE_CONTROLLER_USECASE_GRID_SECTION_HEADER'
                ),
                'name' => 'translation',
            ),
            array(
                'header' => __('AUDIOFILE_CONTROLLER_USECASE_GRID_ACTIV_HEADER'),
                'headerHtmlOptions' => array('data-translation-id' => 'AUDIOFILE_CONTROLLER_USECASE_GRID_ACTIV_HEADER'),
                'type' => 'raw',
                'value' => array($this, 'renderUseCaseCheckbox')
            )
        );
        return $columns;
    }

    public function renderUseCaseCheckbox($data, $row, $column)
    {
        if ($data['isNewRecord']) {
            $checked = true;
        } else {
            $checked = AudioFileUseCase::compare($data['currentUseCase'], $data['flag']);
        }
        return CHtml::checkbox("usecases[" . $data['name'] . "]", $checked, array('value' => $data['flag']));
    }
}
